## pytables 3.4.2

=== requirements.txt ===
# Keep in sync with tables/req_versions.py and
# doc/source/usersguide/installation.rst
numpy>=1.8.0
numexpr>=2.5.2
six>=1.9.0

=== c-blosc/CMakeLists.txt ===
# CMake build system for Blosc
# ============================
#
# Available options:
#
#   BUILD_STATIC: default ON
#       build the static version of the Blosc library
#   BUILD_SHARED: default ON
#       build the shared library version of the Blosc library
#   BUILD_TESTS: default ON
#       build test programs and generates the "test" target
#   BUILD_BENCHMARKS: default ON
#       build the benchmark program
#   DEACTIVATE_AVX2: default OFF
#       do not attempt to build with AVX2 instructions
#   DEACTIVATE_LZ4: default OFF
#       do not include support for the LZ4 library
#   DEACTIVATE_SNAPPY: default OFF
#       do not include support for the Snappy library
#   DEACTIVATE_ZLIB: default OFF
#       do not include support for the Zlib library
#   DEACTIVATE_ZSTD: default OFF
#       do not include support for the Zstd library
#   PREFER_EXTERNAL_LZ4: default OFF
#       when found, use the installed LZ4 libs instead of included
#       sources
#   PREFER_EXTERNAL_SNAPPY: default ON
#       when found, use the installed Snappy libs instead of included
#       sources
#   PREFER_EXTERNAL_ZLIB: default ON
#       when found, use the installed zlib libs instead of included
#       sources
#   PREFER_EXTERNAL_ZSTD: default OFF
#       when found, use the installed zstd libs instead of included
#       sources
#   TEST_INCLUDE_BENCH_SHUFFLE_1: default ON
#       add a test that runs the benchmark program passing "shuffle" with 1
#       thread as second parameter
#   TEST_INCLUDE_BENCH_SHUFFLE_N: default ON
#       add a test that runs the benchmark program passing "shuffle" with all
#       threads as second parameter
#   TEST_INCLUDE_BENCH_BITSHUFFLE_1: default ON
#       add a test that runs the benchmark program passing "bitshuffle" with 1
#       thread as second parameter
#   TEST_INCLUDE_BENCH_BITSHUFFLE_N: default ON
#       add a test that runs the benchmark program passing "bitshuffle" with
#       all threads as second parameter
#   TEST_INCLUDE_BENCH_SUITE: default OFF
#       add a test that runs the benchmark program passing "suite"
#       as first parameter
#   TEST_INCLUDE_BENCH_SUITE_PARALLEL: default OFF
#       add a test that runs the benchmark program passing "parallel"
#       as first parameter
#   TEST_INCLUDE_BENCH_HARDSUITE: default OFF
#       add a test that runs the benchmark program passing "hardsuite"
#       as first parameter
#   TEST_INCLUDE_BENCH_EXTREMESUITE: default OFF
#       add a test that runs the benchmark program passing "extremesuite"
#       as first parameter
#   TEST_INCLUDE_BENCH_DEBUGSUITE: default OFF
#       add a test that runs the benchmark program passing "debugsuite"
#       as first parameter
#
# Components:
#
#    LIB: includes blosc.so
#    DEV: static includes blosc.a and blosc.h


cmake_minimum_required(VERSION 2.8.10)
if (NOT CMAKE_VERSION VERSION_LESS 3.3)
    cmake_policy(SET CMP0063 NEW)
endif()
project(blosc)

# parse the full version numbers from blosc.h
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/blosc/blosc.h _blosc_h_contents)
string(REGEX REPLACE ".*#define[ \t]+BLOSC_VERSION_MAJOR[ \t]+([0-9]+).*"
     "\\1" BLOSC_VERSION_MAJOR ${_blosc_h_contents})
string(REGEX REPLACE ".*#define[ \t]+BLOSC_VERSION_MINOR[ \t]+([0-9]+).*"
    "\\1" BLOSC_VERSION_MINOR ${_blosc_h_contents})
string(REGEX REPLACE ".*#define[ \t]+BLOSC_VERSION_RELEASE[ \t]+([0-9]+).*"
    "\\1" BLOSC_VERSION_PATCH ${_blosc_h_contents})
string(REGEX REPLACE ".*#define[ \t]+BLOSC_VERSION_STRING[ \t]+\"([-0-9A-Za-z.]+)\".*"
    "\\1" BLOSC_VERSION_STRING ${_blosc_h_contents})

message("Configuring for Blosc version: " ${BLOSC_VERSION_STRING})

# options
option(BUILD_STATIC
    "Build a static version of the blosc library." ON)
option(BUILD_SHARED
    "Build a shared library version of the blosc library." ON)
option(BUILD_TESTS
    "Build test programs form the blosc compression library" ON)
option(BUILD_BENCHMARKS
    "Build benchmark programs form the blosc compression library" ON)
option(DEACTIVATE_AVX2
    "Do not attempt to build with AVX2 instructions" OFF)
option(DEACTIVATE_LZ4
    "Do not include support for the LZ4 library." OFF)
option(DEACTIVATE_SNAPPY
    "Do not include support for the Snappy library." OFF)
option(DEACTIVATE_ZLIB
    "Do not include support for the Zlib library." OFF)
option(DEACTIVATE_ZSTD
    "Do not include support for the Zstd library." OFF)
option(PREFER_EXTERNAL_LZ4
    "Find and use external LZ4 library instead of included sources." OFF)
option(PREFER_EXTERNAL_SNAPPY
    "Find and use external Snappy library instead of included sources." ON)
option(PREFER_EXTERNAL_ZLIB
    "Find and use external Zlib library instead of included sources." ON)
option(PREFER_EXTERNAL_ZSTD
    "Find and use external Zstd library instead of included sources." ON)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")


if(NOT DEACTIVATE_LZ4)
    if(PREFER_EXTERNAL_LZ4)
        find_package(LZ4)
    else()
        message(STATUS "Using LZ4 internal sources.")
    endif(PREFER_EXTERNAL_LZ4)
    # HAVE_LZ4 will be set to true because even if the library is
    # not found, we will use the included sources for it
    set(HAVE_LZ4 TRUE)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if(PREFER_EXTERNAL_SNAPPY)
        find_package(Snappy)
    else()
        message(STATUS "Using Snappy internal sources.")
    endif(PREFER_EXTERNAL_SNAPPY)
    # HAVE_SNAPPY will be set to true because even if the library is not found,
    # we will use the included sources for it
    set(HAVE_SNAPPY TRUE)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    # import the ZLIB_ROOT environment variable to help finding the zlib library
    if(PREFER_EXTERNAL_ZLIB)
        set(ZLIB_ROOT $ENV{ZLIB_ROOT})
        find_package(ZLIB)
        if (NOT ZLIB_FOUND )
            message(STATUS "No zlib found.  Using internal sources.")
        endif (NOT ZLIB_FOUND )
    else()
        message(STATUS "Using zlib internal sources.")
    endif(PREFER_EXTERNAL_ZLIB)
    # HAVE_ZLIB will be set to true because even if the library is not found,
    # we will use the included sources for it
    set(HAVE_ZLIB TRUE)
endif(NOT DEACTIVATE_ZLIB)

if (NOT DEACTIVATE_ZSTD)
    if (PREFER_EXTERNAL_ZSTD)
        find_package(Zstd)
    else ()
        message(STATUS "Using ZSTD internal sources.")
    endif (PREFER_EXTERNAL_ZSTD)
    # HAVE_ZSTD will be set to true because even if the library is
    # not found, we will use the included sources for it
    set(HAVE_ZSTD TRUE)
endif (NOT DEACTIVATE_ZSTD)

# create the config.h file
configure_file ("blosc/config.h.in"  "blosc/config.h" )

# now make sure that you set the build directory on your "Include" path when compiling
include_directories("${PROJECT_BINARY_DIR}/blosc/")

# If the build type is not set, default to Release.
set(BLOSC_DEFAULT_BUILD_TYPE Release)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "No build type specified. Defaulting to '${BLOSC_DEFAULT_BUILD_TYPE}'.")
    set(CMAKE_BUILD_TYPE ${BLOSC_DEFAULT_BUILD_TYPE} CACHE STRING
        "Choose the type of build." FORCE)

    # Set the possible values of build type for cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
        "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if(APPLE)
  # enable @rpath in the install name for any shared library being built.  See #175.
  set(CMAKE_MACOSX_RPATH TRUE)
endif()

# Based on the target system's processor and the compiler being used,
# set build variables indicating which hardware features can be targeted
# by the compiler. Note we DO NOT check which hardware features are supported
# by this (the host) system, because we want to be able to support compiling
# for newer hardware on older machines as well as cross-compilation.
message(STATUS "Building for system processor ${CMAKE_SYSTEM_PROCESSOR}")
if(CMAKE_SYSTEM_PROCESSOR STREQUAL i386 OR
   CMAKE_SYSTEM_PROCESSOR STREQUAL i686 OR
   CMAKE_SYSTEM_PROCESSOR STREQUAL x86_64 OR
   CMAKE_SYSTEM_PROCESSOR STREQUAL amd64 OR
   CMAKE_SYSTEM_PROCESSOR STREQUAL AMD64)
    if(CMAKE_C_COMPILER_ID STREQUAL GNU)
        # We need C99 (GNU99 more exactly)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
        set(COMPILER_SUPPORT_SSE2 TRUE)
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.7 OR CMAKE_C_COMPILER_VERSION VERSION_EQUAL 4.7)
            set(COMPILER_SUPPORT_AVX2 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX2 FALSE)
        endif()
    elseif(CMAKE_C_COMPILER_ID STREQUAL Clang)
        set(COMPILER_SUPPORT_SSE2 TRUE)
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 3.2 OR CMAKE_C_COMPILER_VERSION VERSION_EQUAL 3.2)
            set(COMPILER_SUPPORT_AVX2 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX2 FALSE)
        endif()
    elseif(CMAKE_C_COMPILER_ID STREQUAL Intel)
        set(COMPILER_SUPPORT_SSE2 TRUE)
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 14.0 OR CMAKE_C_COMPILER_VERSION VERSION_EQUAL 14.0)
	    # icc (ICC) 15.0.3 does not work compiling AVX2 code
	    # (perhaps my machine does not have AVX2 and the compiler
	    # cannot generate code for that?)
            set(COMPILER_SUPPORT_AVX2 FALSE)
        else()
            set(COMPILER_SUPPORT_AVX2 FALSE)
        endif()
    elseif(MSVC)
        set(COMPILER_SUPPORT_SSE2 TRUE)
        if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 18.00.30501 OR CMAKE_C_COMPILER_VERSION VERSION_EQUAL 18.00.30501)
            set(COMPILER_SUPPORT_AVX2 TRUE)
        else()
            set(COMPILER_SUPPORT_AVX2 FALSE)
        endif()
    else()
        set(COMPILER_SUPPORT_SSE2 FALSE)
        set(COMPILER_SUPPORT_AVX2 FALSE)
        # Unrecognized compiler. Emit a warning message to let the user know hardware-acceleration won't be available.
        message(WARNING "Unable to determine which ${CMAKE_SYSTEM_PROCESSOR} hardware features are supported by the C compiler (${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}).")
    endif()
else()
    # If the target system processor isn't recognized, emit a warning message to alert the user
    # that hardware-acceleration support won't be available but allow configuration to proceed.
    message(WARNING "Unrecognized system processor ${CMAKE_SYSTEM_PROCESSOR}. Cannot determine which hardware features (${CMAKE_C_COMPILER_ID} ${CMAKE_C_COMPILER_VERSION}) supports, so hardware-accelerated implementations will not be available.")
endif()

# disable AVX2 if specified
if(DEACTIVATE_AVX2)
    set(COMPILER_SUPPORT_AVX2 FALSE)
endif()

# flags
# @TODO: set -Wall
# @NOTE: -O3 is enabled in Release mode (CMAKE_BUILD_TYPE="Release")

# Set the "-msse2" build flag only if the CMAKE_C_FLAGS is not already set.
# Probably "-msse2" should be appended to CMAKE_C_FLAGS_RELEASE.
if(CMAKE_C_COMPILER_ID STREQUAL GNU OR CMAKE_C_COMPILER_ID STREQUAL Clang OR CMAKE_C_COMPILER_ID STREQUAL Intel)
     if(NOT CMAKE_C_FLAGS AND COMPILER_SUPPORT_SSE2)
         set(CMAKE_C_FLAGS -msse2 CACHE STRING "C flags." FORCE)
     endif(NOT CMAKE_C_FLAGS AND COMPILER_SUPPORT_SSE2)
endif(CMAKE_C_COMPILER_ID STREQUAL GNU OR CMAKE_C_COMPILER_ID STREQUAL Clang OR CMAKE_C_COMPILER_ID STREQUAL Intel)

if(MSVC)
    if(NOT CMAKE_C_FLAGS)
        set(CMAKE_C_FLAGS "/Ox" CACHE STRING "C flags." FORCE)
    endif(NOT CMAKE_C_FLAGS)

    # Turn off misguided "secure CRT" warnings in MSVC.
    # Microsoft wants people to use the MS-specific <function>_s
    # versions of certain C functions but this is difficult to do
    # in platform-independent code.
    add_definitions( -D_CRT_SECURE_NO_WARNINGS )
endif(MSVC)

if(WIN32)
    # For some supporting headers
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/blosc")
endif(WIN32)

if (NOT DEFINED BLOSC_IS_SUBPROJECT)
  if ("^${CMAKE_SOURCE_DIR}$" STREQUAL "^${PROJECT_SOURCE_DIR}$")
    set (BLOSC_IS_SUBPROJECT FALSE)
  else ()
    set (BLOSC_IS_SUBPROJECT TRUE)
    message(STATUS "Detected that BLOSC is used a subproject.")
  endif ()
endif ()

if (NOT DEFINED BLOSC_INSTALL)

=== c-blosc/blosc/CMakeLists.txt ===
# a simple way to detect that we are using CMAKE
add_definitions(-DUSING_CMAKE)

set(INTERNAL_LIBS ${PROJECT_SOURCE_DIR}/internal-complibs)

# Hide symbols by default unless they're specifically exported.
# This makes it easier to keep the set of exported symbols the
# same across all compilers/platforms.
set(CMAKE_C_VISIBILITY_PRESET hidden)

# includes
set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
if(NOT DEACTIVATE_LZ4)
    if (LZ4_FOUND)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${LZ4_INCLUDE_DIR})
    else(LZ4_FOUND)
        set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.7.5)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${LZ4_LOCAL_DIR})
    endif(LZ4_FOUND)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if (SNAPPY_FOUND)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${SNAPPY_INCLUDE_DIR})
    else(SNAPPY_FOUND)
        set(SNAPPY_LOCAL_DIR ${INTERNAL_LIBS}/snappy-1.1.1)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${SNAPPY_LOCAL_DIR})
    endif(SNAPPY_FOUND)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    if (ZLIB_FOUND)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${ZLIB_INCLUDE_DIR})
    else(ZLIB_FOUND)
        set(ZLIB_LOCAL_DIR ${INTERNAL_LIBS}/zlib-1.2.8)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${ZLIB_LOCAL_DIR})
    endif(ZLIB_FOUND)
endif(NOT DEACTIVATE_ZLIB)

if (NOT DEACTIVATE_ZSTD)
    if (ZSTD_FOUND)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${ZSTD_INCLUDE_DIR})
    else (ZSTD_FOUND)
        set(ZSTD_LOCAL_DIR ${INTERNAL_LIBS}/zstd-1.1.3)
        set(BLOSC_INCLUDE_DIRS ${BLOSC_INCLUDE_DIRS} ${ZSTD_LOCAL_DIR} ${ZSTD_LOCAL_DIR}/common)
    endif (ZSTD_FOUND)
endif (NOT DEACTIVATE_ZSTD)

include_directories(${BLOSC_INCLUDE_DIRS})

# library sources
set(SOURCES blosc.c blosclz.c shuffle-generic.c bitshuffle-generic.c)
if(COMPILER_SUPPORT_SSE2)
    message(STATUS "Adding run-time support for SSE2")
    set(SOURCES ${SOURCES} shuffle-sse2.c bitshuffle-sse2.c)
endif(COMPILER_SUPPORT_SSE2)
if(COMPILER_SUPPORT_AVX2)
    message(STATUS "Adding run-time support for AVX2")
    set(SOURCES ${SOURCES} shuffle-avx2.c bitshuffle-avx2.c)
endif(COMPILER_SUPPORT_AVX2)
set(SOURCES ${SOURCES} shuffle.c)

# library install directory
set(lib_dir lib${LIB_SUFFIX})
set(version_string ${BLOSC_VERSION_MAJOR}.${BLOSC_VERSION_MINOR}.${BLOSC_VERSION_PATCH})

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
if(WIN32)
    # try to use the system library
    find_package(Threads)
    if(NOT Threads_FOUND)
        message(STATUS "using the internal pthread library for win32 systems.")
        set(SOURCES ${SOURCES} win32/pthread.c)
    else(NOT Threads_FOUND)
        set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
    endif(NOT Threads_FOUND)
else(WIN32)
    find_package(Threads REQUIRED)
    set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
endif(WIN32)

if(NOT DEACTIVATE_LZ4)
    if(LZ4_FOUND)
        set(LIBS ${LIBS} ${LZ4_LIBRARY})
    else(LZ4_FOUND)
        file(GLOB LZ4_FILES ${LZ4_LOCAL_DIR}/*.c)
        set(SOURCES ${SOURCES} ${LZ4_FILES})
    endif(LZ4_FOUND)
endif(NOT DEACTIVATE_LZ4)

if(NOT DEACTIVATE_SNAPPY)
    if(SNAPPY_FOUND)
        set(LIBS ${LIBS} ${SNAPPY_LIBRARY})
    else(SNAPPY_FOUND)
        file(GLOB SNAPPY_FILES ${SNAPPY_LOCAL_DIR}/*.cc)
        set(SOURCES ${SOURCES} ${SNAPPY_FILES})
    endif(SNAPPY_FOUND)
endif(NOT DEACTIVATE_SNAPPY)

if(NOT DEACTIVATE_ZLIB)
    if(ZLIB_FOUND)
        set(LIBS ${LIBS} ${ZLIB_LIBRARY})
    else(ZLIB_FOUND)
        file(GLOB ZLIB_FILES ${ZLIB_LOCAL_DIR}/*.c)
        set(SOURCES ${SOURCES} ${ZLIB_FILES})
    endif(ZLIB_FOUND)
endif(NOT DEACTIVATE_ZLIB)

if (NOT DEACTIVATE_ZSTD)
    if (ZSTD_FOUND)
        set(LIBS ${LIBS} ${ZSTD_LIBRARY})
    else (ZSTD_FOUND)
      file(GLOB ZSTD_FILES
        ${ZSTD_LOCAL_DIR}/common/*.c
        ${ZSTD_LOCAL_DIR}/compress/*.c
        ${ZSTD_LOCAL_DIR}/decompress/*.c)
        set(SOURCES ${SOURCES} ${ZSTD_FILES})
    endif (ZSTD_FOUND)
endif (NOT DEACTIVATE_ZSTD)


# targets
if (BUILD_SHARED)
    add_library(blosc_shared SHARED ${SOURCES})
    set_target_properties(blosc_shared PROPERTIES OUTPUT_NAME blosc)
    set_target_properties(blosc_shared PROPERTIES
            VERSION ${version_string}
            SOVERSION 1  # Change this when an ABI change happens
        )
    set_property(
        TARGET blosc_shared
        APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_SHARED_LIBRARY)
endif()

# Based on the target architecture and hardware features supported
# by the C compiler, set hardware architecture optimization flags
# for specific shuffle implementations.
if(COMPILER_SUPPORT_SSE2)
    if (MSVC)
        # MSVC targets SSE2 by default on 64-bit configurations, but not 32-bit configurations.
        if (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
            set_source_files_properties(shuffle-sse2.c bitshuffle-sse2.c PROPERTIES COMPILE_FLAGS "/arch:SSE2")
        endif (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
    else (MSVC)
        set_source_files_properties(shuffle-sse2.c bitshuffle-sse2.c PROPERTIES COMPILE_FLAGS -msse2)
    endif (MSVC)

    # Define a symbol for the shuffle-dispatch implementation
    # so it knows SSE2 is supported even though that file is
    # compiled without SSE2 support (for portability).
    set_property(
        SOURCE shuffle.c
        APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_SSE2_ENABLED)
endif(COMPILER_SUPPORT_SSE2)
if(COMPILER_SUPPORT_AVX2)
    if (MSVC)
        set_source_files_properties(shuffle-avx2.c bitshuffle-avx2.c PROPERTIES COMPILE_FLAGS "/arch:AVX2")
    else (MSVC)
        set_source_files_properties(shuffle-avx2.c bitshuffle-avx2.c PROPERTIES COMPILE_FLAGS -mavx2)
    endif (MSVC)

    # Define a symbol for the shuffle-dispatch implementation
    # so it knows AVX2 is supported even though that file is
    # compiled without AVX2 support (for portability).
    set_property(
        SOURCE shuffle.c
        APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_AVX2_ENABLED)
endif(COMPILER_SUPPORT_AVX2)

# When the option has been selected to compile the test suite,
# compile an additional version of blosc_shared which exports
# some normally-hidden symbols (to facilitate unit testing).
if (BUILD_TESTS)
    add_library(blosc_shared_testing SHARED ${SOURCES})
    set_target_properties(blosc_shared_testing PROPERTIES OUTPUT_NAME blosc_testing)
    set_property(
        TARGET blosc_shared_testing
        APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_SHARED_LIBRARY)
    set_property(
        TARGET blosc_shared_testing
        APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_TESTING)
    # TEMP : CMake doesn't automatically add -lpthread here like it does
    # for the blosc_shared target. Force it for now.
    if(UNIX)
        set_property(
            TARGET blosc_shared_testing
            APPEND PROPERTY LINK_FLAGS "-lpthread")
    endif()
endif()

if (BUILD_SHARED)
    target_link_libraries(blosc_shared ${LIBS})
    target_include_directories(blosc_shared PUBLIC ${BLOSC_INCLUDE_DIRS})
endif()

if (BUILD_TESTS)
    target_link_libraries(blosc_shared_testing ${LIBS})
    target_include_directories(blosc_shared_testing PUBLIC ${BLOSC_INCLUDE_DIRS})
endif()

if(BUILD_STATIC)
    add_library(blosc_static STATIC ${SOURCES})
    set_target_properties(blosc_static PROPERTIES OUTPUT_NAME blosc)
    if (MSVC)
        set_target_properties(blosc_static PROPERTIES PREFIX lib)
    endif()
    target_link_libraries(blosc_static ${LIBS})
    target_include_directories(blosc_static PUBLIC ${BLOSC_INCLUDE_DIRS})
endif(BUILD_STATIC)

# install
if(BLOSC_INSTALL)
    install(FILES blosc.h blosc-export.h DESTINATION include COMPONENT DEV)
    install(TARGETS blosc_shared DESTINATION ${lib_dir} COMPONENT LIB)
    if(BUILD_STATIC)
        install(TARGETS blosc_static DESTINATION ${lib_dir} COMPONENT DEV)
    endif(BUILD_STATIC)
endif(BLOSC_INSTALL)

=== c-blosc/tests/CMakeLists.txt ===
# sources
#aux_source_directory(. SOURCES)
file(GLOB SOURCES test_*.c)

# flags
link_directories(${PROJECT_BINARY_DIR}/blosc)

# targets and tests
foreach(source ${SOURCES})
    get_filename_component(target ${source} NAME_WE)

    # test_nolock and test_noinit will be enabled only for Unix
    if(WIN32)
        if (target STREQUAL test_nolock OR
            target STREQUAL test_noinit OR
            target STREQUAL test_compressor)
            message("Skipping ${target} on Windows systems")
            continue()
        endif()
    endif()

    # test_compressor will be enabled only when LZ4 support is in
    if(target STREQUAL test_compressor AND DEACTIVATE_LZ4)
        message("Skipping ${target} on non-LZ4 builds")
        continue()
    endif()

    # Enable support for testing accelerated shuffles
    if(COMPILER_SUPPORT_SSE2)
        # Define a symbol so tests for SSE2 shuffle/unshuffle will be compiled in.
        set_property(
            SOURCE ${source}
            APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_SSE2_ENABLED)
    endif(COMPILER_SUPPORT_SSE2)
#    if(COMPILER_SUPPORT_AVX2)
#        # Define a symbol so tests for AVX2 shuffle/unshuffle will be compiled in.
#        set_property(
#            SOURCE ${source}
#            APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_AVX2_ENABLED)
#    endif(COMPILER_SUPPORT_AVX2)

    add_executable(${target} ${source})

    # Define the BLOSC_TESTING symbol so normally-hidden functions
    # aren't hidden from the view of the test programs.
    set_property(
        TARGET ${target}
        APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_TESTING)

    # have to copy dlls for Visual Studio
    if(MSVC)
        if(MSVC_VERSION EQUAL 1500)
            # This is an attempt to make VS2008 work, but no luck...
            # https://cmake.org/pipermail/cmake/2014-October/058777.html
            SET(Configuration "Release")
        endif()
        add_custom_command(
            TARGET      ${target}
            POST_BUILD
            COMMAND     ${CMAKE_COMMAND}
            ARGS        -E copy_if_different
                        "${PROJECT_BINARY_DIR}/blosc/\$\(Configuration\)/blosc_testing.dll"
                        "${CMAKE_CURRENT_BINARY_DIR}/\$\(Configuration\)/blosc_testing.dll")
    elseif(MINGW)
        add_custom_command(
            TARGET      ${target}
            POST_BUILD
            COMMAND     ${CMAKE_COMMAND}
            ARGS        -E copy_if_different
                        "${PROJECT_BINARY_DIR}/blosc/libblosc_testing.dll"
                        "${CMAKE_CURRENT_BINARY_DIR}/libblosc_testing.dll")
    endif()

    target_link_libraries(${target} blosc_testing)
    add_dependencies(${target} blosc_shared_testing)

    # If there's a CSV file present for this test, read it to get the list
    # of test parameters then add a test for each parameter set.
    # Otherwise, this is a simple test so just add it once.
    get_filename_component(source_extension ${source} EXT)
    string(REGEX REPLACE "${source_extension}$" ".csv"
        test_params_file ${source})
    if (EXISTS "${test_params_file}")
        # Read the file contents into a CMake list
        file(READ "${test_params_file}" test_params_contents)

        string(REGEX REPLACE ";" "\\\\;"
            test_params_contents "${test_params_contents}")
        string(REGEX REPLACE "\n" ";"
            test_params_contents "${test_params_contents}")

        # How many parameter sets for this test?
        # If there's not at least one (accounting for the CSV header line),
        # that's probably not correct so emit an error and stop configuring.
        list(LENGTH test_params_contents test_params_count)
        if ("${test_params_count}" LESS 2)
            message(ERROR "Invalid test parameters file: ${test_params_file}")
        endif()

        # Remove the header line.
        list(REMOVE_AT test_params_contents 0)

        # Add a test for each parameter set in the file.
        foreach(test_params_raw ${test_params_contents})
            string(REGEX REPLACE "," " " test_params "${test_params_raw}")

            # Create the test name.
            # NOTE: The documentation for add_test says the test name "may not contain
            # spaces, quotes, or other characters special in CMake syntax."
            string(REGEX REPLACE "\"| " "_" test_name_params "${test_params}")
            set(test_name "${target}_${test_name_params}")

            separate_arguments(test_params)
            add_test(${test_name} ${target} ${test_params})
        endforeach()
    else()
        add_test(${target} ${target})
    endif()
endforeach(source)

=== c-blosc/tests/Makefile ===
CC=gcc
CFLAGS=-O3 -Wall -pthread
LDFLAGS=-pthread
BLOSC_LIB= $(wildcard ../blosc/*.c)

# The list of executables
# Generated PNG (intermediate) files
SOURCES := $(wildcard *.c)
EXECUTABLES := $(patsubst %.c, %.exe, $(SOURCES))

# Support for internal LZ4 and LZ4HC
LZ4_DIR = ../internal-complibs/lz4-1.7.5
CFLAGS += -DHAVE_LZ4 -I$(LZ4_DIR)
BLOSC_LIB += $(wildcard $(LZ4_DIR)/*.c)

# Support for external LZ4 and LZ4HC
#LDFLAGS += -DHAVE_LZ4 -llz4

# Support for internal Snappy
#SNAPPY_DIR = ../internal-complibs/snappy-1.1.1
#CFLAGS += -DHAVE_SNAPPY -I$(SNAPPY_DIR)
#BLOSC_LIB += $(wildcard $(SNAPPY_DIR)/*.cc)

# Support for external Snappy
LDFLAGS += -DHAVE_SNAPPY -lsnappy

# Support for external Zlib
LDFLAGS += -DHAVE_ZLIB -lz

# Support for internal Zlib
#ZLIB_DIR = ../internal-complibs/zlib-1.2.8
#CFLAGS += -DHAVE_ZLIB -I$(ZLIB_DIR)
#BLOSC_LIB += $(wildcard $(ZLIB_DIR)/*.c)


# Support for internal Zstd
ZSTD_DIR = ../internal-complibs/zstd-1.1.3
CFLAGS += -DHAVE_ZSTD -I$(ZSTD_DIR) -I$(ZSTD_DIR)/common
BLOSC_LIB += $(wildcard $(ZSTD_DIR)/*/*.c)


.PHONY: all
all: $(EXECUTABLES)

test: $(EXECUTABLES)
	sh test_all.sh

%.exe: %.c $(BLOSC_LIB)
	$(CC) $(CFLAGS) $(LDFLAGS) "$<" $(BLOSC_LIB) -o "$@"

clean:
	rm -rf $(EXECUTABLES)

=== debian/changelog ===
pytables (3.4.2-4) unstable; urgency=medium

  * debian/control
    - python-tables-doc (>= 3.4.2-3) tries to overwrite files in older
      python-tables.
      Set the proper package dependency relations (Closes: #891023).

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sun, 25 Feb 2018 12:07:35 +0000

pytables (3.4.2-3) unstable; urgency=medium

  * Standard version bumped to v4.1.3 (no changes)
  * Set compat to 11
  * Update lintian overrides
  * Fix 0005-usepackage-threeparttable.patch (Closes: #888177)
  * debian/control
    - suggest python(3)-netcdf4 instead of python-netcdf
    - drop build dependency from python3-mock (Closes: #876841)
    - update package description (Closes: #664441)
  * Do not install duplicate files
  * python-tables-doc depends on libjs-mathjax (Closes: #877277)
  * debian/patches
    - refresh all patches
    - new 0006-Use-mock-form-stdlib.patch

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Fri, 02 Feb 2018 07:39:49 +0000

pytables (3.4.2-2) unstable; urgency=medium

  * Standard version bumped to v4.1.1 (extra --> optional)
  * debian/control
    - declare break/replace rules: python3-tables (>= 3.4.2-1) install
      scripts that was previously installed by python-tables
      (Closes: #881741)
    - remove break/replace rules for pytables << 3.0.0-3:
      no longer necessary
  * debian/tests/control
    - reformat
    - re-enable tests on python3-dbg
  * add debian/source.lintian-overrides

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 18 Nov 2017 11:58:23 +0000

pytables (3.4.2-1) unstable; urgency=medium

  * New upstream release (Closes: #874362)
  * Standard version bumped to v4.1.0 (no change)
  * Ensure that autopkgtest scripts return the correct exit code
    (Closes: #864395)
  * debian/patches:
    - drop 0003-Do-not-fetch-icons-for-external-web-sites.patch,
      0004-fix-compatibility-with-HDF5-1.10.patch,
      0005-Ignore-cpuinfo-on-unsupported-archs.patch and
      0006-allow-for-long-type-in-nextafter: applied upstream
    - refresh remainimg patches
    - new 0003-use-local-mathjax.patch
    - new 0004-unicode-charecter-for-latexpdf.patch
    - new 0005-usepackage-threeparttable.patch (compatibility
      with sphinx >= 1.6)
  * Updated copyright file
  * debian/control
    - add build dependency from python(3)-sphinx-rtd-theme,
      python(3)-ipython, python(3)-numpydoc and python-mock
    - add dependency from libjs-mathjax and python(3)-mock
    - depend on python3-sphinx instead of pyhton-sphinx
    - build-depend on latexmk that is required bt sphinx >= 1.6
      (Closes: #872314)
    - remove un-necessary "Testsuite: autopkgtest"
  * Install scripts (and related manpages) for the python3 version
    of the package
  * debian/rules
    - no longer use dpkg-parsechangelog to determine the current
      package timestamp
    - avoid duplicate files in the doc
    - improve clean target
  * debian/source/lintian-overrides
    - new lintian overrides for library-package-name-for-application
      and application-in-library-section

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 23 Sep 2017 11:56:40 +0000

=== debian/control ===
Source: pytables
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Antonio Valentino <antonio.valentino@tiscali.it>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: python
Priority: optional
Build-Depends: debhelper (>= 11),
               dh-python,
               locales,
               libhdf5-dev,
               python-all-dev,
               python-all-dbg,
               python3-all-dev,
               python3-all-dbg,
               python-setuptools,
               python3-setuptools,
               python-six,
               python3-six,
               python-numpy,
               python-numpy-dbg,
               python3-numpy,
               python3-numpy-dbg,
               python-numexpr,
               python-numexpr-dbg,
               python3-numexpr,
               python3-numexpr-dbg,
               python-mock,
               cython,
               cython-dbg,
               cython3,
               cython3-dbg,
               zlib1g-dev,
               liblzo2-dev,
               libblosc-dev,
               liblz4-dev (>= 0.0~r122),
               libsnappy-dev,
               libbz2-dev,
               libzstd-dev,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               python3-ipython,
               python3-numpydoc,
               texlive-generic-extra,
               texlive-latex-recommended,
               texlive-latex-extra,
               texlive-fonts-recommended,
               libjs-jquery-cookie,
               libjs-mathjax,
               latexmk
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/pytables.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/pytables.git
Homepage: http://www.pytables.org
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2

Package: python-tables
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
         python-tables-lib (>= ${source:Version}),
         python-tables-lib (<< ${source:Version}.1~),
         python-tables-data (= ${source:Version}),
         python-numexpr,
         python-mock
Suggests: python-tables-doc (>= 3.4.2-3),
          python-netcdf4,
          vitables
Description: hierarchical database for Python based on HDF5
 PyTables is a package for managing hierarchical datasets and designed
 to efficiently cope with extremely large amounts of data.
 .
 It is built on top of the HDF5 library and the NumPy package. It
 features an object-oriented interface that, combined with C extensions
 for the performance-critical parts of the code (generated using
 Cython), makes it a fast, yet extremely easy to use tool for
 interactively save and retrieve very large amounts of data. One
 important feature of PyTables is that it optimizes memory and disk
 resources so that they take much less space (between a factor 3 to 5,
 and more if the data is compressible) than other solutions, like for
 example, relational or object oriented databases.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy objects.
 .
 This is the Python 2 version of the package.

Package: python-tables-lib
Architecture: any
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: python-tables (= ${source:Version})
Description: hierarchical database for Python based on HDF5 (extension)
 PyTables is a package for managing hierarchical datasets and designed
 to efficiently cope with extremely large amounts of data.
 .
 It is built on top of the HDF5 library and the NumPy package. It
 features an object-oriented interface that, combined with C extensions
 for the performance-critical parts of the code (generated using
 Cython), makes it a fast, yet extremely easy to use tool for
 interactively save and retrieve very large amounts of data. One
 important feature of PyTables is that it optimizes memory and disk
 resources so that they take much less space (between a factor 3 to 5,
 and more if the data is compressible) than other solutions, like for
 example, relational or object oriented databases.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy objects.
 .
 This package contains the extension built for the Python 2 interpreter.

Package: python-tables-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends},
         ${python:Depends},
         ${shlibs:Depends},
         python-tables (= ${source:Version}),
         python-tables-lib (= ${binary:Version}),
         python-dbg,
         python-numpy-dbg,
         python-numexpr-dbg
Suggests: python-tables-doc,
          python-netcdf4
Description: hierarchical database for Python based on HDF5 (debug extension)
 PyTables is a package for managing hierarchical datasets and designed
 to efficiently cope with extremely large amounts of data.
 .
 It is built on top of the HDF5 library and the NumPy package. It
 features an object-oriented interface that, combined with C extensions
 for the performance-critical parts of the code (generated using
 Cython), makes it a fast, yet extremely easy to use tool for
 interactively save and retrieve very large amounts of data. One
 important feature of PyTables is that it optimizes memory and disk
 resources so that they take much less space (between a factor 3 to 5,
 and more if the data is compressible) than other solutions, like for
 example, relational or object oriented databases.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy objects.
 .
 This package contains the extension built for the Python 2 debug interpreter.

Package: python3-tables
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-tables-lib (>= ${source:Version}),
         python3-tables-lib (<< ${source:Version}.1~),
         python-tables-data (= ${source:Version}),
         python3-numexpr
Suggests: python-tables-doc (>> 3.4.2-3),
          python3-netcdf4,
          vitables
Replaces: python-tables (<< 3.4.2-1)
Breaks: python-tables (<< 3.4.2-1)
Description: hierarchical database for Python3 based on HDF5
 PyTables is a package for managing hierarchical datasets and designed
 to efficiently cope with extremely large amounts of data.
 .
 It is built on top of the HDF5 library and the NumPy package. It
 features an object-oriented interface that, combined with C extensions
 for the performance-critical parts of the code (generated using
 Cython), makes it a fast, yet extremely easy to use tool for
 interactively save and retrieve very large amounts of data. One
 important feature of PyTables is that it optimizes memory and disk
 resources so that they take much less space (between a factor 3 to 5,
 and more if the data is compressible) than other solutions, like for
 example, relational or object oriented databases.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy objects.
 .
 This is the Python 3 version of the package.

Package: python3-tables-lib
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-tables (= ${source:Version})
Description: hierarchical database for Python3 based on HDF5 (extension)
 PyTables is a package for managing hierarchical datasets and designed
 to efficiently cope with extremely large amounts of data.
 .
 It is built on top of the HDF5 library and the NumPy package. It
 features an object-oriented interface that, combined with C extensions
 for the performance-critical parts of the code (generated using
 Cython), makes it a fast, yet extremely easy to use tool for
 interactively save and retrieve very large amounts of data. One
 important feature of PyTables is that it optimizes memory and disk
 resources so that they take much less space (between a factor 3 to 5,
 and more if the data is compressible) than other solutions, like for
 example, relational or object oriented databases.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy objects.
 .
 This package contains the extension built for the Python 3 interpreter.

Package: python3-tables-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         python3-tables (= ${source:Version}),
         python3-tables-lib (= ${binary:Version}),
         python3-dbg,
         python3-numpy-dbg,
         python3-numexpr-dbg
Suggests: python-tables-doc,
          python3-netcdf4
Description: hierarchical database for Python 3 based on HDF5 (debug extension)
 PyTables is a package for managing hierarchical datasets and designed
 to efficiently cope with extremely large amounts of data.
 .
 It is built on top of the HDF5 library and the NumPy package. It
 features an object-oriented interface that, combined with C extensions
 for the performance-critical parts of the code (generated using
 Cython), makes it a fast, yet extremely easy to use tool for
 interactively save and retrieve very large amounts of data. One
 important feature of PyTables is that it optimizes memory and disk
 resources so that they take much less space (between a factor 3 to 5,
 and more if the data is compressible) than other solutions, like for
 example, relational or object oriented databases.
 .
  - Compound types (records) can be used entirely from Python (i.e. it
    is not necessary to use C for taking advantage of them).
  - The tables are both enlargeable and compressible.
  - I/O is buffered, so you can get very fast I/O, specially with
    large tables.
  - Very easy to select data through the use of iterators over the
    rows in tables. Extended slicing is supported as well.
  - It supports the complete set of NumPy objects.
 .
 This package contains the extension built for the Python 3 debug interpreter.

Package: python-tables-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
         libjs-jquery-cookie
Suggests: xpdf | pdf-viewer,
          www-browser
Replaces: python-tables (<< 3.4.2-3)
Breaks: python-tables (<< 3.4.2-3)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

# Get the supported Python versions
PY2VERS = $(shell pyversions -r -v)
PY3VERS = $(shell py3versions -r -v)

include /usr/share/dpkg/pkg-info.mk
BUILD_DATE="$(date --utc --date="@${SOURCE_DATE_EPOCH:-$(date +%s)}" +%Y-%m-%d)"
SPHINXOPTS := -D today=\"$(BUILD_DATE)\"
SPHINXOPTS += -D html_last_updated_fmt=\"$(BUILD_DATE)\"

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
  export CFLAGS ?= -O0
endif

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  export HDF5_DIR := /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif


%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem=python_distutils


build-python%:
	python$* setup.py build
	python$*-dbg setup.py build


override_dh_auto_build: $(PY3VERS:%=build-python%)
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(MAKE) PWD=$(CURDIR) SPHINXOPTS="$(SPHINXOPTS)"
	$(MAKE) -C doc PWD=$(CURDIR) SPHINXOPTS="$(SPHINXOPTS)" latexpdf
	mv doc/build/latex/usersguide-*.pdf doc/usersguide.pdf
else
	$(MAKE) ANNOUNCE.txt
	$(MAKE) -C src all
	mkdir -p doc/html
	touch doc/usersguide.pdf
endif
	dh_auto_build --buildsystem=python_distutils


install-python%:
	python$* setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb
	python$*-dbg setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb


override_dh_auto_install: $(PY3VERS:%=install-python%)
	dh_auto_install


override_dh_install:
	# Install everything excluding the *.so extensions to python(3)-tables
	dh_install -X"*.so" -X"*.h5" -X"*.xbm" -X"*.dat" -X"*.mat" "debian/tmp/usr/lib/python2*" -p python-tables
	dh_install -X"*.so" -X"*.h5" -X"*.xbm" -X"*.dat" -X"*.mat" "debian/tmp/usr/lib/python3*" -p python3-tables

	# Install the extensions to python(3)-tables-lib
	dh_install -X"*_d.so" "debian/tmp/usr/lib/python2*/*-packages/tables/*.so" -p python-tables-lib
	find debian/python-tables-lib -name '*_d.so' | xargs -r rm -f
	dh_install -X"*dmu.so" -X"*dm.so" "debian/tmp/usr/lib/python3*/*-packages/tables/*.so" -p python3-tables-lib
	find debian/python3-tables-lib -name '*.cpython-??dm-*.so' | xargs -r rm -f

	# Install the debug extensions to python(3)-tables-dbg
	dh_install "debian/tmp/usr/lib/python2*/*-packages/tables/*_d.so" -p python-tables-dbg
	dh_install "debian/tmp/usr/lib/python3*/*-packages/tables/*.cpython-??dm*.so" -p python3-tables-dbg

	# Continue with regular dh_install
	dh_install -p python-tables-doc
	dh_install -p python-tables-data

	# link data files
	for py in $(PY2VERS); do \
		for f in debian/tmp/usr/lib/python2*/*-packages/tables/tests/*.h5 \
		         debian/tmp/usr/lib/python2*/*-packages/tables/tests/*.mat; do \
			dh_link -p python-tables usr/share/python-tables/tests/$$(basename $$f) usr/lib/python$$py/dist-packages/tables/tests/$$(basename $$f); \
		done; \
		for f in debian/tmp/usr/lib/python2*/*-packages/tables/nodes/tests/*.h5 \
		         debian/tmp/usr/lib/python2*/*-packages/tables/nodes/tests/*.xbm \
		         debian/tmp/usr/lib/python2*/*-packages/tables/nodes/tests/*.dat; do \
			dh_link -p python-tables usr/share/python-tables/nodes/tests/$$(basename $$f) usr/lib/python$$py/dist-packages/tables/nodes/tests/$$(basename $$f); \
		done; \
	done

	for f in debian/tmp/usr/lib/python3*/*-packages/tables/tests/*.h5 \
	         debian/tmp/usr/lib/python3*/*-packages/tables/tests/*.mat; do \
		dh_link -p python3-tables usr/share/python-tables/tests/$$(basename $$f) usr/lib/python3/dist-packages/tables/tests/$$(basename $$f); \
	done
	for f in debian/tmp/usr/lib/python3*/*-packages/tables/nodes/tests/*.h5 \
	         debian/tmp/usr/lib/python3*/*-packages/tables/nodes/tests/*.xbm \
	         debian/tmp/usr/lib/python3*/*-packages/tables/nodes/tests/*.dat; do \
		dh_link -p python3-tables usr/share/python-tables/nodes/tests/$$(basename $$f) usr/lib/python3/dist-packages/tables/nodes/tests/$$(basename $$f); \
	done

	dh_numpy
	dh_numpy3
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# https://github.com/PyTables/PyTables/issues/485
	mkdir -p $(CURDIR)/tmp-locales
	localedef -i /usr/share/i18n/locales/en_US -c -f UTF-8 \
		-A /usr/share/locale/locale.alias \
		$(CURDIR)/tmp-locales/en_US.UTF-8
	set -e -x; \
	for py in $(PY2VERS); do \
		cd $(CURDIR)/build/lib.*-$$py; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py tables/tests/test_all.py -vvv; \
		cd $(CURDIR)/debian/tmp/usr/lib/python$$py/dist-packages; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py-dbg tables/tests/test_all.py -vvv; \
	done
	set -e -x; \
	for py in $(PY3VERS); do \
		cd $(CURDIR)/build/lib.*-$$py; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py tables/tests/test_all.py -vvv; \
		cd $(CURDIR)/debian/tmp/usr/lib/python3/dist-packages; \
		env PYTHONPATH=. \
			LOCPATH=$(CURDIR)/tmp-locales LC_ALL=en_US.UTF-8 \
			python$$py-dbg tables/tests/test_all.py -vvv; \
	done
endif


override_dh_strip:
	dh_strip -ppython-tables-lib  --dbg-package=python-tables-dbg
	dh_strip -ppython3-tables-lib --dbg-package=python3-tables-dbg


override_dh_auto_clean:
	# Avoid unnecessary cythonization (see
	# https://github.com/PyTables/PyTables/issues/122)
	#dh_auto_clean --buildsystem=python_distutils
	$(MAKE) distclean
	rm -rf doc/*.pdf tables.egg-info tmp-locales


override_dh_sphinxdoc:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_sphinxdoc -ppython-tables-doc
	rm -f $(CURDIR)/debian/python-tables-doc/usr/share/doc/python-tables-doc/html/_static/jquery.cookie.js
	rm -f debian/tmp/usr/share/doc/python-tables-doc/html/_downloads/simple_threading.py
	rm -f debian/tmp/usr/share/doc/python-tables-doc/html/_downloads/threading_monkeypatch.py
	rm -f debian/tmp/usr/share/doc/python-tables-doc/html/_sources/release-notes/RELEASE_NOTES_v2.1.x-pro.rst.txt
endif


override_dh_installchangelogs:
	dh_installchangelogs -k RELEASE_NOTES.txt


override_dh_compress:
	dh_compress -X.txt -X.pdf -X.py -X.h5


.PHONY: override_dh_auto_build override_dh_auto_install override_dh_auto_clean \
        override_dh_sphinxdoc override_dh_install \
        override_dh_installchangelogs override_dh_compress

=== debian/tests/control ===
Tests: python2,
       python2-dbg,
       python3,
       python3-dbg
Depends: python-tables,
         python-all,
         python-tables-dbg,
         python-all-dbg,
         python3-tables,
         python3-all,
         python3-tables-dbg,
         python3-all-dbg

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v\.?(\d\S*)\.tar\.gz/PyTables-$1\.tar\.gz/ \
  https://github.com/PyTables/PyTables/tags .*/v\.?(\d\S*)\.tar\.gz
